
#ifndef _simpleQVTK_h
#define _simpleQVTK_h


#include "vav3DViewer.h"
#include "CVector3d.h"
#include "CMatrix3d.h"
#include <list>
using namespace std;


class vtkTransform;
class vtk3DSImporter;
class vavROI;


class SimpleQVTK : public vav3DViewer
{
	Q_OBJECT

public:
	SimpleQVTK( QWidget *parent=0 );

	// MEMBER FUNCTIONS
	void TransformFromHapticWorld( cVector3d hapticPos, double *pos );

// MEMBER VARIABLES
public:
	vtkTransform *Transform, *GlobalSceneTransform;
	vtk3DSImporter *ModelImporter;
	std::list<vavROI*> ROIList;
	vavROI *HapticCursor;
	double HapticCursorPosition[3];

// PUBLIC SLOTS
public slots:

	// SLOT for catching the SIGNALS sent from the Haptic-Messenger
	void DeleteROI(char *roiName);
	void AddROI(char*, cVector3d, double);
	void TransfromROI(char*, cVector3d, cMatrix3d);
	void ScaleROI(char*, double);

	void ChangeSlicePosition(double, double, double);

	void SceneRotated(cMatrix3d VtK_Rotation_Global);
	void SceneRotated2(cVector3d axis, double rotAngle);

	void UpdateHapticCursor(cVector3d);

	void Test();


};

#endif
