
#ifndef _simple_h
#define _simple_h


// include files
#include <QGLWidget>
#include <QThread>
#include <QMutex>

#include "CCamera.h"
#include "CLight.h"
#include "CWorld.h"
#include "CMesh.h"
#include "CTriangle.h"
#include "CVertex.h"
#include "CMaterial.h"
#include "CTexture2D.h"
#include "CMatrix3d.h"
#include "CVector3d.h"
#include "CPrecisionClock.h"
#include "CPrecisionTimer.h"
#include "CMeta3dofPointer.h"
#include "CShapeTorus.h"
#include "CShapeSphere.h"
#include "CBitmap.h"
#include "CLabelPanel.h"


// forward declarations
//class cCamera;
//class cMesh;
//class cMeta3dofPointer;
// class UpdateThread;

// class definition
class Simple : public QGLWidget
{
	Q_OBJECT

public:
	// CONSTRUCTOR
	Simple(QWidget *parent = 0);

	// wrapper to update the contents of the OpenGL window
	void Redraw();

	// initialize the haptic cursor
	void Initialize( cMeta3dofPointer *_cursor, cMesh *_CoorSystem, int *_Milliseconds_Rate_Update,double *_ROI_Scale_Factor,double *_CoorSystem_Rotation_Factor );


// OVERRIDDEN VIRTUAL FUNCTIONS
protected:
	void initializeGL();
	void resizeGL(int width, int height);
	void paintGL();
	void mousePressEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	void mouseDoubleClickEvent(QMouseEvent *event);
	void keyPressEvent(QKeyEvent *);

// MEMBER VARIABLES
public:
	int width, height;
	// UpdateThread *updateDisplayThread;

	// HAPTICS-RELATED
	double HapticCursorPosition[3];
	cCamera *camera;
	cMeta3dofPointer *cursor;
	cMesh *CoorSystem;
	int *Milliseconds_Rate_Update,Object_Number;
	cMesh *CurObject;
	double *ROI_Scale_Factor,*CoorSystem_Rotation_Factor;


// PUBLIC SLOTS
public slots:
	void UpdateView();

// SIGNALS
signals:
	void HapticCursorPositionChanged(double*);
};



//class UpdateThread : public QThread
//{
//	Q_OBJECT
//public:
//	UpdateThread( QWidget *parent=0 );
//
//protected:
//	void run();
//
//public:
//	Simple *simpleGLWidget;
//
//signals:
//	void UpdateView();
//};

#endif