

#include "vavHapticMessenger.h"
#include "CVector3d.h"
#include "CMatrix3d.h"
#include <QWidget>
#include <QTimer>
#include <iostream>
using std::cout;
using std::endl;

//--------------------------------------------------------------------------------
vavHapticMessenger::vavHapticMessenger( QWidget *parent ) : QObject(parent)
{
	QTimer *timer = new QTimer(this);
	connect(timer, SIGNAL(timeout()), this, SLOT(Update()));
	timer->start(5);

	HapticLoopfunction = NULL;
}


//--------------------------------------------------------------------------------
void vavHapticMessenger::Update()
{
	if( HapticLoopfunction != NULL )
		(*HapticLoopfunction)(NULL);
}


//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_DeleteROI_Signal(char *roiName)
{ emit DeleteROI(roiName); }


//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_AddROI_Signal(char *roiName, cVector3d roiPosition, double radius)
{ emit AddROI(roiName, roiPosition, radius); }


//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_TransfromROI_Signal(char *roiName, cVector3d roiPosition, cMatrix3d roiRotation)
{ emit TransfromROI(roiName, roiPosition, roiRotation); }


//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_ScaleROI_Signal(char *roiName, double scaleFactor)
{ emit ScaleROI(roiName, scaleFactor); }




//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_ChangeSlicePosition_Signal(cVector3d slicePositions)
{	
	// cout << "slice pos -> " << slicePositions.x << " " << slicePositions.y << " "  << slicePositions.z << " "  << endl;
	emit ChangeSlicePosition(slicePositions.x, slicePositions.y, slicePositions.z);
}


//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_SceneRotated_Signal(cMatrix3d VtK_Rotation_Global)
{ emit SceneRotated(VtK_Rotation_Global); }


//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_SceneRotated2_Signal(cVector3d VtK_Rotation_Global, double rotAngle)
{ emit SceneRotated2(VtK_Rotation_Global, rotAngle); }



//--------------------------------------------------------------------------------
void vavHapticMessenger::Emit_UpdateHapticCursor_Signal(cVector3d pos)
{ emit UpdateHapticCursor(pos); }